;EasyCodeName=VideoCam,1
.Const

app_width		Equ 350
app_height		Equ 315


.Data?

;==============================================;
; CAPTUREPARMS struct is not defined in MASM32 ;
;==============================================;
CAPTUREPARMS Struct
	dwRequestMicroSecPerFrame	DD	? ; Requested capture rate
	fMakeUserHitOKToCapture		DD	? ; Show "Hit OK to cap" dlg?
	wPercentDropForError		DD	? ; Give error msg if > (10%)
	fYield						DD	? ; Capture via background task?
	dwIndexSize					DD	? ; Max index size in frames (32K)
	wChunkGranularity			DD	? ; Junk chunk granularity (2K)
	fUsingDOSMemory				DD	? ; Use DOS buffers?
	wNumVideoRequested			DD	? ; # video buffers, If 0, autocalc
	fCaptureAudio				DD	? ; Capture audio?
	wNumAudioRequested			DD	? ; # audio buffers, If 0, autocalc
	vKeyAbort					DD	? ; Virtual key causing abort
	fAbortLeftMouse				DD	? ; Abort on left mouse?
	fAbortRightMouse			DD	? ; Abort on right mouse?
	fLimitEnabled				DD	? ; Use wTimeLimit?
	wTimeLimit					DD	? ; Seconds to capture
	fMCIControl					DD	? ; Use MCI video source?
	fStepMCIDevice				DD	? ; Step MCI device?
	dwMCIStartTime				DD	? ; Time to start in MS
	dwMCIStopTime				DD	? ; Time to stop in MS
	fStepCaptureAt2x			DD	? ; Perform spatial averaging 2x
	wStepCaptureAverageFrames	DD	? ; Temporal average n Frames
	dwAudioBufferSize			DD	? ; Size of audio bufs (0 = default)
	fDisableWriteCache			DD	? ; Attempt to disable write cache
	AVStreamMaster				DD	? ; Which stream controls length?
CAPTUREPARMS EndS

hInstance		DD	?
hCap			DD	?
hWnd			DD	?
hIcon			DD	?
CommandLine		DD	?
cp				CAPTUREPARMS <?>


.Data

szClassName		DB "VCam_Class", 0
szAppName		DB "Cam Demo", 0
szVideoName		DB "Demo Cap", 0

.Code

start:
	Invoke GetModuleHandle, NULL
	Mov [hInstance], Eax
	Invoke WinMain, [hInstance], NULL, NULL, SW_SHOWDEFAULT
	Invoke ExitProcess, Eax

WinMain Proc hModule:DWord, hPrevInstance:DWord, lpCmdLine:DWord, nCmdShow:DWord
	Local wc:WNDCLASSEX
	Local msg:MSG

	Invoke LoadIcon, hModule, IDC_MAINICON    ; icon ID
	Mov hIcon, Eax
	Mov wc.cbSize, SizeOf WNDCLASSEX
	Mov wc.style, CS_HREDRAW Or CS_VREDRAW Or CS_BYTEALIGNWINDOW
	Mov wc.lpfnWndProc, Offset WinProc
	Mov wc.cbClsExtra, NULL
	Mov wc.cbWndExtra, NULL
	Mov Eax, hModule
	Mov wc.hInstance, Eax
	Mov wc.hbrBackground, COLOR_BTNFACE + 1
	Mov wc.lpszMenuName, NULL
	Mov wc.lpszClassName, Offset szClassName
	Mov Eax, hIcon
	Mov wc.hIcon, Eax
	Mov wc.hIconSm, Eax
	Invoke LoadCursor, NULL, IDC_ARROW
	Mov wc.hCursor, Eax
	Invoke RegisterClassEx, Addr wc
	Invoke CreateWindowEx, WS_EX_LEFT, Addr szClassName, Addr szAppName, WS_CAPTION Or WS_SYSMENU Or WS_MINIMIZEBOX Or WS_POPUP Or WS_VISIBLE Or WS_BORDER Or WS_DLGFRAME, 0, 0, app_width, app_height, NULL, NULL, hModule, NULL
	Mov hWnd, Eax
	Invoke ShowWindow, hWnd, SW_SHOWNORMAL
	Invoke UpdateWindow, hWnd
	;********************************************************************
	; The code for this CAM control doe not have to go here, it can go
	; into the main PROC or anywhere, I just put it here so that the
	; window will show right away so the user knows it's working
	; couse some cam's take awhile to startup.
	;********************************************************************
	Invoke capCreateCaptureWindow, Addr szVideoName,
								   WS_BORDER Or WS_CHILD Or WS_VISIBLE,
                                   10, 20, 320, 240, hWnd, 2000

	Mov [hCap], Eax
	Invoke SendMessage, hCap, WM_CAP_DRIVER_CONNECT, 0, 0
	Invoke SendMessage, hCap, WM_CAP_GET_SEQUENCE_SETUP, SizeOf cp, Addr cp
	Mov [cp.fStepCaptureAt2x], TRUE
	Invoke SendMessage, hCap, WM_CAP_DLG_VIDEODISPLAY, 0, 0
	Invoke SendMessage, hCap, WM_CAP_SET_SEQUENCE_SETUP, SizeOf cp, Addr cp
	Invoke SendMessage, hCap, WM_CAP_SET_SCALE, TRUE, 0
	Invoke SendMessage, hCap, WM_CAP_SET_PREVIEWRATE, 60, 0
	Invoke SendMessage, hCap, WM_CAP_SET_PREVIEW, TRUE, 0

StartLoop:
	Invoke GetMessage, Addr msg, NULL, 0, 0
	Cmp Eax, 0
	Je ExitLoop
	Invoke TranslateMessage, Addr msg
	Invoke DispatchMessage, Addr msg
	Jmp StartLoop
ExitLoop:
	Return msg.wParam
WinMain EndP

;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
WinProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	.If uMsg == WM_CREATE
		Invoke CenterWindow, hWin
		;Timer identifier = 10 - Timer frequency = 1000 mS (1 second)
		Invoke SetTimer, hWin, 10, 1000, 0

	.ElseIf uMsg == WM_PAINT

	.ElseIf uMsg == WM_TIMER
		;Code for timer goes here
		Return TRUE

	.ElseIf uMsg == WM_COMMAND

	.ElseIf uMsg == WM_SIZE

	.ElseIf uMsg == WM_CLOSE
		Invoke DestroyIcon, hIcon
		Invoke KillTimer, hWin, 10
		Invoke DestroyWindow, hWin

	.ElseIf uMsg == WM_DESTROY
		Invoke PostQuitMessage, 0
		Return 0
	.EndIf

	Invoke DefWindowProc, hWin, uMsg, wParam, lParam
	Ret
WinProc EndP

CenterWindow Proc Uses Ebx Ecx Edx Edi Esi hWin:DWord
	Local Wtx:DWord
	Local Wty:DWord
	Local Wwd:DWord
	Local Wht:DWord
	Local rect:RECT

	Invoke GetWindowRect, hWin, Addr rect
	Mov Eax, [rect.right]
	Sub Eax, [rect.left]
	Mov [Wwd], Eax
	Mov Eax, [rect.bottom]
	Sub Eax, [rect.top]
	Mov [Wht], Eax
	Invoke GetSystemMetrics, SM_CXSCREEN
	Shr Eax, 1      ; divide screen X by 2
	Mov Ebx, Wwd    ; Get window X value
	Shr Ebx, 1      ; divide window X by 2
	Sub Eax, Ebx    ; sub half win X from half screen X
	Mov Wtx, Eax
	Invoke GetSystemMetrics, SM_CYSCREEN
	Shr Eax, 1      ; divide screen Y by 2
	Mov Ebx, Wht    ; Get window Y value
	Shr Ebx, 1      ; divide window Y by 2
	Sub Eax, Ebx    ; sub half win Y from half screen Y
	Mov Wty, Eax
	Invoke SetWindowPos, hWin, 0, Wtx, Wty, 0, 0, SWP_NOZORDER Or SWP_NOSIZE
	Ret
CenterWindow EndP

End start
